// Onewire-Bibliothek für C, nicht für C++. Für PIC16F1459.
// Mit Suchfunktion für mehrere Temperatursensoren
// Vorlage: Arduino-Bibliothek

typedef unsigned char byte;
typedef byte rom_t[8];

#include <stdbool.h>

// Perform a 1-Wire reset cycle. Returns true if a device responds
// with a presence pulse. Takes  250 µs
bool owReset(void);
// Issue a 1-Wire rom select command, you do the reset first.
#define owSelect(rom) {owWriteByte(0x55);owWrite(rom,8);}

// Issue a 1-Wire rom skip command, to address all on bus.
#define owSkip() owWriteByte(0xCC);

// Write. The wire is held high at the end
// for parasitically powered devices.
void owWriteBit(byte);
void owWriteByte(byte);
void owWrite(const byte*,byte len);

// Read
bool owReadBit(void);
byte owReadByte(void);
void owRead(byte*,byte len);

// Clear the search state so that if will start from the beginning again.
void owsReset(void);

#if 0
// Setup the search to find the device type 'family_code' on the next call
// to search(*newAddr) if it is present.
void owsTarget(byte);

// Look for the next device. Returns 1 if a new address has been
// returned. A zero might mean that the bus is shorted, there are
// no devices, or you have already retrieved all of them.  It
// might be a good idea to check the CRC to make sure you didn't
// get garbage.  The order is deterministic. You will always get
// the same devices in the same order.
bool owsSearch(rom_t);

// Compute a Dallas Semiconductor 8 bit CRC, these are used in the
// ROM and scratchpad registers.
byte owCrc8(const byte*,byte len);
#endif

void delay_ticks(unsigned t);
#define __delay_ms(ms) delay_ticks((unsigned)((ms)*32.768))

void memcpy(byte*dst,const byte*src,byte len);
void memset(byte*dst,byte data,byte len);
